/*
                                                                                                                                                   + /*
    Sounds 
    000..059: Minuten
    060..065: Zehn-Sekunden
    066..089: Stunden
    090: Kein Anschluss unter dieser Nummer
    091: Beim naechsten Ton ist es
    092: Piep
    093: Freizeichen
*/


//I/O Makros DCF77-Empfaenger
#define   DI_DCF77 12
#define   DI_LAUT  11

#define BUSY 2
#define CLK  7
#define DATA 8
#define WAIT 10  //ms

int count=0;
byte dcfSekunde;
byte stoerung;
byte uhrSS=0, uhrMM=1, uhrHH=9, uhr10s, zeitEmpfangen;
static unsigned long tic=0;  
bool playsound=false;
byte soundNr=0;
bool laut;

//------------------------------------------------------------------------------
void PlayFileWt5001(void) { //use serial interface to tell WT5001 what to do
//------------------------------------------------------------------------------
static byte step=0;
    switch (step) {
      case 0: if (playsound)                step++; break;
      case 1: Serial.write(0x7E);           step++; break;  // Start code
      case 2: Serial.write(4);              step++; break;  // length
      case 3: Serial.write(0xA0);           step++; break;  // Command
      case 4: Serial.write(0);              step++; break;  // soundNr H
      case 5: Serial.write(soundNr+1 );     step++; break;  // soundNr L
      case 6: Serial.write(0x7E);           step++; break;  // End code
      case 7: if (digitalRead(BUSY))        step++; break;  // wait until WT5001 is playing
      case 8: if (!digitalRead(BUSY))       step++; break;  // wait until WT5001 has finished
      default: playsound=false;             step=0; break;  
    }
}


//------------------------------------------------------------------------------
void ansage() {
//------------------------------------------------------------------------------
  static byte old10s=99;
  static byte step=0;
  static unsigned long ms=0;  
  if (old10s != uhr10s) {
    switch(step) {
      case 0: soundNr=92; playsound=true;         step++; break;
      case 1: if (!playsound){ ms=millis();       step++; } break;  
      case 2: if ((millis() - ms) >= 1000) {      //delay 1000ms
            if (laut){ 
                volumeHigh();
                laut = false;
            }else{
                volumeLow();
            }
            step++; 
        }
        break; 
      case 3: soundNr=91; playsound=true;         step++; break; //Beim nächsten Ton ist es
      case 4: if (!playsound)                     step++; break;  
      case 5: soundNr=66+uhrHH; playsound=true;   step++; break; //Zehn Uhr
      case 6: if (!playsound)                     step++; break;  
      case 7: soundNr=uhrMM; playsound=true;      step++; break; //zwanzig Minuten
      case 8: if (!playsound)                     step++; break;  
      case 9: soundNr=60+uhr10s; playsound=true;  step++; break; //und 30 Sekunden
      case 10: if (!playsound)                    step++; break;  
      default: old10s = uhr10s;                   step=0; break;
    }
  }
}


//------------------------------------------------------------------------------
void decodeDCF77(void){  //Alle 5ms aufrufen
//------------------------------------------------------------------------------
static int iTic=0; 
static int iTiefpass=0; 
static bool bSteigend=0;
static byte nZeitumstellung=0;
static byte hs=0;
static byte hh=0;
static byte mm=0;
static byte ss=0;
static byte tag=0;
static byte wtag=0;
static byte monat=0;
static byte jahr=0;
static byte keinEmpfang=0;
static byte neuesDatum=0;
static bool bToggle;
static byte sommerzeit;
static byte winterzeit;
static byte startphase=1;
static byte bChecksum=0;
static byte zeitUebernehmen;    
static byte bBit[60];      //die empfangenen Bits
static byte erfolgreichdecodiert;
static byte vorHH; //Die empfangene Zeit in der letzten Minute
static byte vorMM;
static byte vorJJ;
static byte ms50;    
byte i;

    iTic+=5;  //5ms sind rum
    if (iTic>3000){ //Kein Signal
      iTic=3000;
    }
    //Eingang abfragen und filtern
    if (digitalRead(DI_DCF77)){ //Signalabsenkung liefert High am DCF-Modul für 100ms oder 200ms. Über Fet wird daraus LOW am Eingang für 100-200ms
      if (0==zeitEmpfangen) digitalWrite(13, LOW); //Dauerleuchten, wenn Zeit korrekt empfangen
      iTiefpass-=5;
      if (iTiefpass<0){
        iTiefpass=0;
        bSteigend=1;
      }
    }else{
      iTiefpass+=5;
      digitalWrite(13, HIGH);
      if (iTiefpass>200) iTiefpass=200;  //auf 200ms begrenzen
    }


    //Minutenanfang erkennen
    if (iTic > 1500){ //Minutensignal: mehr als 1s keine Absenkung
      dcfSekunde=59;
    }
    else
    //Signallänge bestimmen und im Bitfeld eintragen
    if (160==iTic){ //160ms  Tiefpass ist entweder +100-60=40 oder +100+60=160
      //pulsdauer=iTiefpass;
      if (iTiefpass > 90){      
        bBit[dcfSekunde]=1;
      }else{
        bBit[dcfSekunde]=0;
	    }
    
      if ((iTiefpass < 5) ||   ((iTiefpass > 60) && (iTiefpass <100))){ //Unplausible Signaldauer
        if (stoerung <4) stoerung++;  
      }else{
        if (stoerung >0) stoerung--;  
      }
    }
    //Sekundenanfang erkennen
    if ((60==iTiefpass) && bSteigend){ //60ms seit Pulsbeginn
      bSteigend=0;
      iTic=60;
      dcfSekunde++;
      if (dcfSekunde>59){  //Jetzt ist Minutenanfang
        dcfSekunde=0;
        if (0==startphase){ //beim 1. Minutenanfang nach Einschalten ist die Zeit noch nicht �bertragen
          zeitUebernehmen = 1;  
        }

        //Auswertung zum Minutenanfang
        if (zeitUebernehmen){
          if (bBit[16]){
            nZeitumstellung++;
            }else{
            if (nZeitumstellung) nZeitumstellung--;
          }
          if (bBit[17]){
            if (sommerzeit < 60) sommerzeit++;
            }else{
            if (sommerzeit) sommerzeit--;
          }
          if (bBit[18]){
            if (winterzeit < 60) winterzeit++;
            }else{
            if (winterzeit) winterzeit--;
          }
          bChecksum=bBit[21]+bBit[22]+bBit[23]+bBit[24]+bBit[25]+bBit[26]+bBit[27]+bBit[28]; //Minute 
          if (0==(bChecksum % 2)){ //P1
            bChecksum=bBit[29]+bBit[30]+bBit[31]+bBit[32]+bBit[33]+bBit[34]+bBit[35];        //Stunde  
            if (0==(bChecksum % 2)){ //P2
              if (bBit[20]){ //Startbit; immer gesetzt
                bChecksum=0;
                for (i=36; i<59; i++){ //Checksumme �ber Datum 
                  bChecksum+=bBit[i];
                }
                if (0==(bChecksum % 2)){ //P3
                  neuesDatum=0;
                  keinEmpfang=0;
                  tag = bBit[36]+bBit[37]*2+bBit[38]*4+bBit[39]*8+bBit[40]*10+bBit[41]*20;
                  wtag = bBit[42]+bBit[43]*2+bBit[44]*4;
                  monat = bBit[45]+bBit[46]*2+bBit[47]*4+bBit[48]*8;
                  jahr = bBit[50]+bBit[51]*2+bBit[52]*4+bBit[53]*8+bBit[54]*10+bBit[55]*20+bBit[56]*40+bBit[57]*80;
                  if (zeitUebernehmen){
                    //Übernehme Zeit
                    zeitUebernehmen = 0;
                    hh = bBit[29]+bBit[30]*2+bBit[31]*4+bBit[32]*8+bBit[33]*10+bBit[34]*20;
                    mm = bBit[21]+bBit[22]*2+bBit[23]*4+bBit[24]*8+bBit[25]*10+bBit[26]*20+bBit[27]*40;
                    ss = 0;
			              //Ist diese Zeit genau eine Minute später als vor einer Minute? (zusätzlicher Plausibilitätscheck)
                    vorMM++;
                    if (vorMM>59){
                      vorMM=0;
                      vorHH++;
                      if (vorHH >23) vorHH=0;
                    }
                    if ((vorHH == hh) 
                    && (vorMM == mm) 
                    && (vorJJ == jahr) //Beim Jahreswechsel muss die Uhr ja nicht um Mitternacht verdreht werden
                    && (jahr>14)){       //Wir haben 2015 - und mehr als bis zum Jahr 2099 soll die Uhr gar nicht laufen
                      erfolgreichdecodiert=1;
                    }  
                    vorHH=hh;
                    vorMM=mm;
                    vorJJ=jahr; 
                  }
                }//P3
              }//Bit20
            }//P2
          }//P1
        }//zeitUebernehmen
        if (startphase) startphase=0;
        for (i=0; i<60; i++){
          bBit[i]=0;
        }
      }//(dcfSekunde>59)
    
      //Interne Uhr feintunen
      //Hundertstel Sekunden hs sollte auf 6 stehen , wenn die Uhr richtig läuft (60ms seit steigender Flanke)
      //Nur machen, wenn Empfang OK
      if ((keinEmpfang < 2) && (0==stoerung)){
        if ((hs > 6) && (hs < 56)) {
          hs --; //Uhr etwas zur�ckdrehen
        }else{
          if (hs != 6){
            hs++; //Uhr etwas vor drehen. Überlauf wird weiter unten automatisch behandelt.
          }  
        }
      }
    }//Sekundenanfang (60ms)

    //Intere Uhr weiterdrehen
    bToggle = !bToggle;
    if (bToggle){ //10ms sind rum
      hs++; //Hundertstel Sekunden
      if (hs>99){ //1s ist rum
        hs-=100; //Nicht auf 0 setzen, um Überlauf bei Uhr vordrehen (Feintuning) zu berücksichtigen
        uhrSS++;
        if (uhrSS > 9){
          uhrSS=0;
          uhr10s++;
          if (uhr10s > 5){
            uhr10s=0;
            uhrMM++;
            if (keinEmpfang < 100){ //Wird bei Empfang mit korreten Pr�fsummen auf 0 gesetzt	
              keinEmpfang++;
            }	
            if (zeitEmpfangen && (keinEmpfang > 15) && (uhrHH > 2) && (uhrHH < 6)) {
  //            displayEnable(0);
            }
            if (uhrMM > 59){
              uhrMM=0;
              uhrHH++;
              if (uhrHH > 23){
                uhrHH=0;
              } 
              //Zeitumstellung?
              if ((nZeitumstellung > 45) && (uhrHH >=2) && (uhrHH <=3)){ //"nZeitumstellung" wurde in der Stunde vor der Umstellung jede Minute hochgez�hlt
                if (sommerzeit > winterzeit){ //MESZ->MEZ
                  uhrHH--;
                }else{ //MEZ->MESZ
                  uhrHH++;
                }
              }
            }//uhrMM>59
          }//uhr10s>5
        }//uhrSS>9
        if (erfolgreichdecodiert){ //Zeit übernehmen (wenn vorhanden)
          erfolgreichdecodiert=0;
          zeitEmpfangen=1;
          uhrHH=hh;
          uhrMM=mm;
          uhrSS=1;
          uhr10s=1;
        }
      }//hs>99
    }//Toggle
}//decodeDCF77



//---------------------------------------------------------------------------------------------------
void volumeLow(void) {
//---------------------------------------------------------------------------------------------------
    Serial.write(0x7E);
    Serial.write(0x03);
    Serial.write(0xA7);
    Serial.write(0x12); //Leises sprechen
    Serial.write(0x7E);
}

//---------------------------------------------------------------------------------------------------
void volumeHigh(void) {
//---------------------------------------------------------------------------------------------------
    Serial.write(0x7E);
    Serial.write(0x03);
    Serial.write(0xA7);  //Volume Control
    Serial.write(0x10);  // Laut
    Serial.write(0x7E);
}



//---------------------------------------------------------------------------------------------------
void setup() {
//---------------------------------------------------------------------------------------------------
    pinMode(13, OUTPUT);  
    pinMode(DI_DCF77,  INPUT_PULLUP);
    pinMode(DI_LAUT,   INPUT_PULLUP);
      
      
    // initialize serial communications with WT5001 at 9600 8N1:
    Serial.begin(9600);    
    delay(3000); 
    volumeHigh();
    delay(2000);
    soundNr=92; //piep
    playsound=true;
}


//---------------------------------------------------------------------------------------------------
void loop() {
//---------------------------------------------------------------------------------------------------
static uint32_t previousMillis = millis();
static uint32_t currentMillis  = 0;
    PlayFileWt5001();
    
    if (zeitEmpfangen){
        ansage();
    }
    
    //---Alle 5ms---
    currentMillis = millis();
    if (currentMillis - previousMillis >=5){ //use unsigned subtraction to correctly handle rollover of millis
        previousMillis += 5;
        decodeDCF77();        
        if (!digitalRead(DI_LAUT)) laut = true;
    }
}
